<?php
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class VendasRealizadasReportHandler extends AReportHandler {
    const dataSourceName = 'vnd41208Q_relVendasRealizadasPeriodoDataExporter';
    
    public function buildNewRequest($request, Response $response) {
        
        $conditions = $this->relService->getParamsAsArray($request);
            
        $this->relService->setTCDandCDChangingKey($conditions, 'CDCAIXA',           'CDFILICAIXA');
        $this->relService->setTCDandCDChangingKey($conditions, 'CLIENFILIAL',       'CDFILICLIENTE');
        $this->relService->setTCDandCDChangingKey($conditions, 'CLIENTECONSUMIDOR', 'CDCONSCLI');
        $this->relService->setTCDandCDChangingKey($conditions, 'CDFILIAL',          'CDFILIAL');
        $this->relService->setIntervalAsDTINIandDTFIM($conditions, 'DTMOVIMENTO',   'DTINI', 'DTFIM');
        unset($conditions['NRORG']);
        
        $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::dataSourceName, $conditions);
        
        return [$newRequest, $response];
    }
}