<?php 

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;

class SelectCcusclie extends CrudWithParameterBag {
    
    protected $parameterBagColumns  = array('NRORG');
    protected $dataSourceName       = 'select_ccusclie';
          
    public function findByCliente(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'select_ccusclieByCliente';
        $this->parameterBagColumns = array('NRORG', 'CDCLIENTE');
        
        $conditions = $request->getFilterCriteria()->getConditions();
        
        if(gettype($conditions[0]['value']) == "array") {
            $conditions[0]['value'] = implode('_',$conditions[0]['value']);
            
            $newRequest = new DTO\Request\Filter(
                new FilterCriteria(
                    $request->getFilterCriteria()->getDataSourceName(),
                    $conditions,
                    $request->getFilterCriteria()->getPage(),
                    $request->getFilterCriteria()->getPageSize()
                ),
                $request->getMethod(),
                $request->getRoutePath(),
                $request->getUserId()
            );
        } else {
            $newRequest = $request;
        }
        
        parent::find($newRequest, $response);
        
        $this->dataSourceName = 'select_ccusclie';
        $this->parameterBagColumns = array('NRORG');
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response){
        $this->dataSourceName = 'select_ccusclie';
        parent::save($request,$response);
    }
    
    public function delete(DTO\Request\DataSet $request, DTO\Response $response){
        $this->dataSourceName = 'select_ccusclie';
        $this->parameterBagColumns = array('NRORG', 'CDCLIENTE', 'CDCCUSCLIE');
        parent::delete($request,$response);
    }
}