<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class Integracao {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function loadPeriodVend(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_VENDAS_PERIODO);
	}

	public function getIntegrationData(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_WEBSERVICE_URL);
	}

	public function getMovExport($CDFILIAL, $CDCAIXA, $DTINIT, $DTFIM, $FIRST, $LAST){
		$params = array(
			':DTINIT' => $DTINIT,
			':DTFIM' => $DTFIM,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':FIRST' => $FIRST,
			':LAST' => $LAST
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_MOV_EXPORT, $params);
	}

	public function getCaixasLiberadosManualmente($CDFILIAL, $CDCAIXA, $DTMOVTURCAIX){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':DTMOVTURCAIX' => $DTMOVTURCAIX
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_MOV_REGISTER, $params);
	}

	public function updateCaixasLiberados($CDFILIAL, $CDCAIXA, $DTMOVTURCAIX){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA,
			':DTMOVTURCAIX' => $DTMOVTURCAIX
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::UPDATE_MOV_REGISTER, $params);
	}


	public function updateERPParams($NMENDWEBSER){
		$params = array(
			':NMENDWEBSER'      => $NMENDWEBSER
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_ERP_PARAMS, $params);
	}

}