<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;

class RelTabelaDePrecoService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function getVigenciaInterval( $NRORG, $CDTABEPREC, $CDFILIAL){
		$params = array(	
			':CDTABEPREC'  => $CDTABEPREC,
			':CDFILIAL'    => $CDFILIAL,
			':NRORG'       => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_VIGENCIA_INTERVAL, $params);
	}
	
	public function find($CDTABEPREC, $CDFILIAL, $DTINI, $DTFIN, $PRODINI, $PRODFIN, $CDNVPRODUTO){
		$params = array(	
			':CDTABEPREC'  => $CDTABEPREC,
			':CDFILIAL'    => $CDFILIAL,
			':DTINIVGPREC' => $DTINI,
			':DTFIN'       => $DTFIN,
			':PRODINI'     => str_replace('%', '', $PRODINI),
			':PRODFIN'     => str_replace('%', '', $PRODFIN),
			':CDNVPRODUTO' => str_replace('%', '', $CDNVPRODUTO)
			
		);
		return $this->entityManager->getConnection()->fetchAll(self::FIND_DATA_RELATORIO, $params);
	}
	
	const GET_VIGENCIA_INTERVAL = "
	SELECT
	  TO_CHAR(DTINIVGPREC, 'DD/MM/YYYY') AS DTINIVGPREC,
	  TO_CHAR(DTFINVGPREC, 'DD/MM/YYYY') AS DTFINVGPREC,
	  'De ' || TO_CHAR(DTINIVGPREC, 'DD/MM/YYYY') || ' até ' || TO_CHAR(DTFINVGPREC, 'DD/MM/YYYY') AS LABELDTVIGENCIA,
	  TO_CHAR(DTINIVGPREC, 'DD/MM/YYYY') || '-' || TO_CHAR(DTFINVGPREC, 'DD/MM/YYYY') AS INTERVALVIGENCIA
	FROM
	  TABEVEND
	WHERE (CDFILIAL = :CDFILIAL)
	  AND (CDTABEPREC = :CDTABEPREC)
	  AND (NRORG = :NRORG)
	ORDER BY DTINIVGPREC
	";
	const FIND_DATA_RELATORIO = "
	   SELECT DISTINCT
		   F.CDFILIAL , F.NMFILIAL , T.CDTABEPREC, TP.NMTABEPREC ,
		   P.CDPRODUTO, P.NMPRODUTO, NVL(I.VRPRECITEM, 0) AS VRPRECITEM, NVL(I.VRPRECITEMCL, 0) AS VRPRECITEMCL,
		   P.CDARVPROD, NVL(VRCUSTITEM, 0) AS VRCUSTITEM, P.CDBARPRODUTO
		FROM
		   TABEVEND T, ITEMPRECO I, FILIAL F, PRODUTO P, TABEPREC TP
		WHERE
		   (I.CDFILIAL    = :CDFILIAL   ) AND
		   (I.CDTABEPREC  = :CDTABEPREC ) AND
		   (I.DTINIVGPREC = :DTINIVGPREC) AND
		   ((P.CDARVPROD BETWEEN :PRODINI AND :PRODFIN)) AND
		   (F.CDFILIAL    = T.CDFILIAL    ) AND
		   (F.CDFILIAL    = I.CDFILIAL    ) AND
		   (I.CDPRODUTO   = P.CDPRODUTO   ) AND
		   (T.CDTABEPREC  = I.CDTABEPREC  ) AND
		   (TP.CDFILIAL   = T.CDFILIAL    ) AND
		   (TP.CDTABEPREC = T.CDTABEPREC  ) AND
		   (P.CDNVPRODUTO = :CDNVPRODUTO  )
		ORDER BY
		    P.CDARVPROD, F.CDFILIAL, T.CDTABEPREC";
}